unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, StdCtrls, Spin, Menus, Buttons;

type
  Tfrm15 = class(TForm)
    Panel1: TPanel;
    GridNumbers: TStringGrid;
    Label2: TLabel;
    SProws: TSpinEdit;
    Label3: TLabel;
    Spcolumns: TSpinEdit;
    spfontsize: TSpinEdit;
    Label4: TLabel;
    StaticText1: TStaticText;
    Timer1: TTimer;
    StaticText2: TStaticText;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    PopupMenu1: TPopupMenu;
    Showmovelog1: TMenuItem;
    MainMenu1: TMainMenu;
    InitMenu: TMenuItem;
    RandomizeMenu: TMenuItem;
    OpenMenu: TMenuItem;
    SaveMenu: TMenuItem;
    HelpMenu: TMenuItem;
    SpTotRandom: TSpinEdit;
    Label1: TLabel;
    File1: TMenuItem;
    Showmovelog2: TMenuItem;
    Help1: TMenuItem;
    Exit1: TMenuItem;
    N151: TMenuItem;
    N501: TMenuItem;
    N5001: TMenuItem;
    Help2: TMenuItem;
    Howtoplay1: TMenuItem;
    About1: TMenuItem;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    StaticText3: TStaticText;
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure GridNumbersDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure GridNumbersKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure SProwsChange(Sender: TObject);
    procedure SpcolumnsChange(Sender: TObject);
    procedure SProwsKeyPress(Sender: TObject; var Key: Char);
    procedure GridNumbersKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure spfontsizeChange(Sender: TObject);
    procedure StaticText1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure StaticText2Click(Sender: TObject);
    procedure InitMenuClick(Sender: TObject);
    procedure RandomizeMenuClick(Sender: TObject);
    procedure OpenMenuClick(Sender: TObject);
    procedure SaveMenuClick(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure Showmovelog2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure N151Click(Sender: TObject);
    procedure N501Click(Sender: TObject);
    procedure N5001Click(Sender: TObject);
    procedure Howtoplay1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure GridNumbersMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure StaticText3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
const HolePosX : integer=0; HolePosY : integer=0;
var
  frm15: Tfrm15;
  countertick,totmoves : integer;
implementation

uses formMoves, Unit2;

{$R *.DFM}

const movedelay : integer =15;

procedure InitGrid;
var i,j,k,m : integer;
begin k:=0;
 with frm15.GridNumbers do
 begin m:=rowcount*colcount-1;
 for i:=0 to rowcount-1 do rows[i].clear;
 for i:=0 to rowcount-1 do
 for j:=0 to colcount-1 do
 begin cells[j,i]:=inttostr(k+1);
       inc(k); if k=m then break
 end;
 row:=rowcount-1; col:=colcount-1; cells[col,row]:=' ';
 HoleposX:=col; HolePosY:=row; countertick:=0; totmoves:=0; setfocus
 end
end;


procedure Tfrm15.FormResize(Sender: TObject);
var i,j : integer;
begin i:=gridnumbers.Height - 2*gridnumbers.RowCount;
      j:=gridnumbers.Width - 2*gridnumbers.ColCount;
      gridnumbers.DefaultColWidth:=j div gridnumbers.ColCount;
      gridnumbers.DefaultRowHeight:=i div gridnumbers.RowCount
end;

procedure Tfrm15.FormShow(Sender: TObject);
begin
 InitGrid; GridNumbers.SetFocus
end;

procedure Tfrm15.GridNumbersDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
  var s : string[3]; w,h,c,m,n : integer;
begin
// if (gdSelected In state)or(gdfixed In state) then
 with gridnumbers do
 begin s:=cells[acol,arow];  canvas.Font:=gridnumbers.Font;
     if (acol=col)and(arow=row)
     then begin c:=clblue; canvas.font.Color:=clyellow;
     end
     else
     begin c:=rgb(0,$FF-strtointdef(s,0),0); canvas.font.Color:=clblack
     end;
     if strtointdef(s,0)=0 then s:=' ';
     canvas.brush.Color:=c; //rgb(0,c,0);
    w:=rect.Right-rect.Left; h:=rect.Bottom-rect.Top;
    m:=canvas.textwidth(s); n:=canvas.textheight(s);
    canvas.fillrect(rect);
    canvas.textout(rect.left+(w-m)div 2,rect.top+(h-n)div 2,s)
 end
end;

procedure ShiftRow;
var i : integer; s : string[100];
begin
 with frm15.gridnumbers do
 begin
   if col>HolePosX then  //shift left
   for i:=HolePosX to col-1 do
   begin cells[i,row]:=cells[i+1,row];
        sleep(movedelay)
   end
   else //shift right
   for i:=HolePosX downto col+1 do
   begin cells[i,row]:=cells[i-1,row];
         sleep(movedelay)
   end;
   with frmmoves.Memo1 do
   begin inc(movecounter); s:=inttostr(movecounter)+') ';
         s:=s+'OldX='+inttostr(holeposx+1)+'     '+
         'OldY='+inttostr(holeposy+1)+'     '+
         'NewX='+inttostr(col+1)+'     '+
         'NewY='+inttostr(row+1);
         lines.Add(s)
   end;
   cells[col,row]:=' '; HoleposX:=col; HolePosY:=row
 end
end;

procedure ShiftColumn;
var i : integer; s : string[100];
begin
 with frm15.gridnumbers do
 begin
   if row>HolePosY then
   for i:=HolePosY to row-1 do
   begin cells[col,i]:=cells[col,i+1];
         sleep(movedelay); refresh
   end
   else
   for i:=HolePosY downto row+1 do
   begin cells[col,i]:=cells[col,i-1];
         sleep(movedelay); refresh
   end;
   with frmmoves.Memo1 do
   begin inc(movecounter); s:=inttostr(movecounter)+') ';
         s:=s+'OldX='+inttostr(holeposx+1)+'     '+
         'OldY='+inttostr(holeposy+1)+'     '+
         'NewX='+inttostr(col+1)+'     '+
         'NewY='+inttostr(row+1);
         lines.Add(s)
   end;
   cells[col,row]:=' '; HoleposX:=col; HolePosY:=row
 end
end;

procedure RandomizeGrid;
var i,k,x,y : integer;
begin randomize;
 with frm15.GridNumbers do
 begin i:=frm15.SpTotRandom.Value; k:=0;
   repeat inc(k);
     repeat y:=random(rowcount)
     until y<>HolePosY;
     row:=y;
     shiftcolumn;
     if k=i then break;
     inc(k);
     repeat x:=random(colcount)
     until x<>HolePosX;
     col:=x;
     shiftrow;
     if k=i then break;
   until false;
   setfocus
 end
end;

procedure Tfrm15.GridNumbersKeyPress(Sender: TObject; var Key: Char);
var  i: integer;
begin
 if key=#13 then with gridnumbers do
 begin if cells[col,row]=' ' then
       begin showmessage('select not empty cell');
             exit
       end;
       for i:=0 to rowcount-1 do if cells[col,i]=' ' then
       begin  shiftcolumn; inc(totmoves); StaticText2.Caption:=inttostr(totmoves);
              exit
       end;
       for i:=0 to colcount-1 do if cells[i,row]=' ' then
       begin shiftrow; inc(totmoves); StaticText2.Caption:=inttostr(totmoves);
             exit
       end;
       showmessage('If you want to shift a row or column the hole must be either in column or row')
 end
end;

procedure Tfrm15.GridNumbersMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var acol,arow,i : integer;
begin
 if button=mbleft then with GridNumbers do
 begin
   mousetocell(x,y,acol,arow);
   for i:=0 to rowcount-1 do if cells[col,i]=' ' then
   begin  shiftcolumn; inc(totmoves); StaticText2.Caption:=inttostr(totmoves);
          exit
   end;
   for i:=0 to colcount-1 do if cells[i,row]=' ' then
   begin shiftrow; inc(totmoves); StaticText2.Caption:=inttostr(totmoves);
         exit
   end;
 end
end;


procedure Tfrm15.FormCreate(Sender: TObject);
begin
 frm15.DoubleBuffered:=true; frm15.ShowHint:=true
end;

procedure Tfrm15.SProwsChange(Sender: TObject);
begin
 with gridnumbers do
 begin RowCount:=sprows.Value; refresh;
       frm15.clientheight:=rowcount*defaultrowheight+15+panel1.Height;
       SpTotRandom.Value:=4*rowcount*colcount
 end;
 initgrid
end;

procedure Tfrm15.SpcolumnsChange(Sender: TObject);
begin
 with gridnumbers do
 begin ColCount:=spcolumns.Value; refresh;
       frm15.Width:=DefaultColWidth*colcount+colcount+5;
       SpTotRandom.Value:=4*rowcount*colcount
 end;
 initgrid
end;

procedure Tfrm15.SProwsKeyPress(Sender: TObject; var Key: Char);
begin
 key:=#0
end;

procedure Tfrm15.GridNumbersKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 with gridnumbers do
 case key of
  vk_right:
   if col=colcount-1 then
    begin col:=0;
          key:=0
    end;
  vk_left:
   if col=0 then
     begin col:=colcount-1;
           key:=0
     end;
  vk_up:
    if row=0 then
       begin row:=rowcount-1;
             key:=0
       end;
  vk_down:
    if row=rowcount-1 then
     begin row:=0;
          key:=0
      end
  end//case
end;

procedure Tfrm15.spfontsizeChange(Sender: TObject);
begin
 gridnumbers.Font.Size:=spfontsize.Value;
 gridnumbers.SetFocus
end;

procedure Tfrm15.StaticText1Click(Sender: TObject);
begin
 countertick:=0; timer1.Enabled:=not(timer1.Enabled)
end;

procedure Tfrm15.Timer1Timer(Sender: TObject);
var minute,second : integer;
begin
 inc(countertick);
 if odd(countertick) then
 begin minute:=countertick div 60;
       second:=countertick mod 60;
       statictext1.Caption:=' '+inttostr(minute)+' : '+inttostr(second)
 end
end;

procedure Tfrm15.StaticText2Click(Sender: TObject);
begin
 totmoves:=0; StaticText2.Caption:='0'
end;

procedure Tfrm15.InitMenuClick(Sender: TObject);
begin
totmoves:=0; totmoves:=0; StaticText2.Caption:='0';
InitGrid; countertick:=0; timer1.Enabled:=true
end;

procedure Tfrm15.RandomizeMenuClick(Sender: TObject);
begin
  RandomizeGrid; countertick:=0; timer1.Enabled:=true
end;

procedure Tfrm15.OpenMenuClick(Sender: TObject);
type Tnum= array[1..2] of char;
var f : file of Tnum; i,j : integer; T : Tnum; s : string[2];
begin if opendialog.Execute=false then exit;
 with Gridnumbers do
 begin
   assignfile(f,opendialog.filename); reset(f);
   i:=filesize(f);
   if i <>rowcount*colcount then
   begin closefile(f);  gridnumbers.SetFocus;
         showmessage('Error number of elements in the file does not match grid size');
         exit
   end;
   for i:=0 to rowcount-1 do
   for j:=0 to colcount-1 do
   begin read(f,t); s:=t; if s[1]=' ' then s:=s[2];
         if s=' ' then
         begin HolePosX:=j; HolePosY:=i

         end;
         cells[j,i]:=s
   end;
   closefile(f);
   showmessage('The square was read successfully');gridnumbers.SetFocus;
 end;
end;

procedure Tfrm15.SaveMenuClick(Sender: TObject);
type Tnum= array[1..2] of char;
var f : file of Tnum; i,j : integer; T : Tnum; s : string[2];
begin if savedialog.Execute=false then exit;
 assignfile(f,savedialog.filename); rewrite(f);
 with Gridnumbers do
 for i:=0 to rowcount-1 do
 for j:=0 to colcount-1 do
 begin s:=cells[j,i]; if length(s)<2 then s:=' '+s;
       t[1]:=s[1]; t[2]:=s[2];
       write(f,T);
 end; closefile(f);gridnumbers.SetFocus;
 showmessage('Numbers in the the square were saved successfully')
end;

procedure Tfrm15.Help1Click(Sender: TObject);
const c =#13#10;
     person1='Dedicated to my good friend and teacher of the year Ann Walker';
begin
 Showmessage('Sort the square/rectangle by shifting thr rows and columns.'+c+
 'Use the arrow keys to go to a column or row where the VOID hole is located.'+c+
 'Press the enter key the the numbers will be automatically shifted up or down for you.'+c+c+
 'This is a good memory game. Theoretically you should be able to unscamble the square'+c+
 'in less than or equal number of random seed you have selected, but most cases that is very difficult'+c+
 person1+c+c+
 'This game was written by Omid Motahed. A simulation of my favorite childhood game'
 );
 Gridnumbers.SetFocus
end;

procedure Tfrm15.Showmovelog2Click(Sender: TObject);
begin
   frmmoves.Show
end;

procedure Tfrm15.Exit1Click(Sender: TObject);
begin
 close
end;

procedure Tfrm15.N151Click(Sender: TObject);
begin
 n151.Checked:=true; movedelay:=15;
 N501.Checked:=false;
 N5001.Checked:=false;
end;

procedure Tfrm15.N501Click(Sender: TObject);
begin
 n151.Checked:=false; movedelay:=50;
 N501.Checked:=true;
 N5001.Checked:=false;

end;

procedure Tfrm15.N5001Click(Sender: TObject);
begin
 n151.Checked:=false; movedelay:=500;
 N501.Checked:=false;
 N5001.Checked:=true;
end;

procedure Tfrm15.Howtoplay1Click(Sender: TObject);
const c =#13#10;
begin
 showmessage(
 'Purpose of this game is very simple, just arrangle the numbers in ascending order'+c+
 'Using the arrow keys move to any row or column that the blank cell is located'+c+
 'Then simply press the enter key. The program will automatically shift the cells')
end;

procedure Tfrm15.About1Click(Sender: TObject);
begin
showmessage('This program was written by Omid Motahed and dedicated to public domain'+#13+
 'Email motahed1@yahoo.com Phone 13439227250'+#13+'Dedicated to my wife Jing YuRung')
end;


procedure Tfrm15.SpeedButton1Click(Sender: TObject);
begin
 statictext2.Caption:='0'; totmoves:=0
end;

procedure Tfrm15.SpeedButton2Click(Sender: TObject);
begin
statictext1.Caption:='0'; countertick:=0
end;

procedure Tfrm15.StaticText3Click(Sender: TObject);
begin
 with frmcontrol do
 begin top:=frm15.Top; left:=frm15.Left-ClientWidth-4;
    ShowModal;
 end
end;

end.
